﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Common;
using System.Runtime.Serialization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Services.Hive.Common.DataTransfer {
  [DataContract]
  [Serializable]
  public abstract class HiveItemBase : IDeepCloneable {
    protected HiveItemBase() { }
    protected HiveItemBase(HiveItemBase original, Cloner cloner) {
      cloner.RegisterClonedObject(original, this);
    }

    public abstract IDeepCloneable Clone(Cloner cloner);

    public object Clone() {
      return Clone(new Cloner());
    }
  }
}
